var settings = new Array();
settings.ticks = 3;

function GETRequest(url) {
  var response;
  $.ajax({
    type: 'GET',
    url: url,
    data: { },
    success: function(content) {
      response = content;
    },
    cache: false,
    async: false
  });
  return response;
}

var chartDivs = 0;
function createChartDiv(id, title, desc, div, zoomable) {
  if ((chartDivs % 2) == 0) {
    $('#' + div).append('<div class="row">');
  }
  $('#' + div).append('\
			<div class="col-md-6">\
				<div class="panel panel-default">\
					<div class="panel-heading">\
						<div class="panel-title-box">\
							<h3>' + title + '</h3>\
							<span>' + desc + '</span>\
						</div>\
						<ul class="panel-controls" style="margin-top: 2px;">\
							<!--li><a href="#" class="panel-fullscreen"><span class="fa fa-expand"></span></a></li>\
							<li class="dropdown">\
								<a href="#" class="dropdown-toggle" data-toggle="dropdown"><span class="fa fa-cog"></span></a>\
								<ul class="dropdown-menu">\
									<li><a href="#" class="panel-collapse"><span class="fa fa-angle-down"></span> Collapse</a></li>\
									<li><a href="#" class="panel-remove"><span class="fa fa-times"></span> Remove</a></li>\
								</ul>\
							</li-->\
                                                        ' + (zoomable ? '<li><a href="#" class="panel-refresh" id="' + id + '-zoomout-btn' + '"><span class="fa fa-search-minus"></span></a></li>' : ' ') + '\
							<li><a href="#" class="panel-refresh" id="' + id + '-refresh-btn' + '"><span class="fa fa-refresh"></span></a></li>\
						</ul>\
					</div>\
					<div class="panel-body padding-0">\
						<div class="chart-holder" id="dashboard-line-1" style="height: auto; position: relative;">\
							<div id="' + id + '">\
								<svg style="height:320px"> </svg>\
							</div>\
						</div>\
					</div>\
				</div>\
			</div>\
  ');
  if ((chartDivs % 2) == 0) {
    $('#' + div).append('</div>');
  }
  chartDivs++;
}

function scalePPSUnit(v) {
  if (v > 1000000) return 'Mpps';
  else if (v > 1000) return 'kpps';
  else return 'pps';
}

function scaleBPSUnit(v) {
  if (v > 1000000000) return 'Gbps';
  else if (v > 1000000) return 'Mbps';
  else if (v > 1000) return 'Kbps';
  else return 'bps';
}

function scaleKByteUnit(v) {
  if (v > 1024*1024) return 'GBytes';
  else if (v > 1024) return 'MBytes';
  else return 'KBytes';
}

function scaleValue(v) {
  if (v > 1000000000) return v/1000000000;
  else if (v > 1000000) return v/1000000;
  else if (v > 1000) return v/1000;
  else return Math.round(v);
}

function scaleByteValue(v) {
  if (v > 1024*1024) return v/(1024*1024);
  else if (v > 1024) return v/1024;
  else return Math.round(v);
}

function scaleFormat(v) {
  if (v > 1000) return ',.1f';
  else return ',.0f';
}

function drawLineChart(url, div, unit, initzoom, inittime) {
  var zoom = initzoom;
  var time = inittime;
  d3.json(url + '?zoom=' + zoom + '&time=' + time, function(data) {
    nv.addGraph(function() {
	var chart = nv.models.lineChart()
		.x(function(d) { return d[0] })
		.y(function(d) {
                        if (unit == 'bps') return d[1]*8;
                        else return d[1]; })
		.color(d3.scale.category10().range())
		.useInteractiveGuideline(true)
		.margin({left: 80, right: 30})
		;

	chart.xAxis
		.ticks(settings.ticks)
		.tickFormat(function(d) {
			return d3.time.format('%b %e %H:%M:%S')(new Date(d*1000));
		});

	chart.yAxis
		.tickFormat(function(d) {
                        if (d < 0) return '';
                        if (unit == 'pps') return d3.format(scaleFormat(d))(scaleValue(d)) + ' ' + scalePPSUnit(d);
                        else if (unit == 'bps') return d3.format(scaleFormat(d))(scaleValue(d)) + ' ' + scaleBPSUnit(d);
                        else if (unit == 'kbytes') return d3.format(',.1f')(scaleByteValue(d)) + ' ' + scaleKByteUnit(d);
                        else return d3.format(',.0f')(d);
		});

	d3.select('#' + div + ' svg')
		.datum(data)
		.call(chart);

	nv.utils.windowResize(chart.update);

        function updateChart() {
          d3.json(url + '?zoom=' + zoom + '&time=' + time, function(data) {
	  	d3.select('#' + div + ' svg')
          		.datum(data).transition().duration(500).call(chart);
          	nv.utils.windowResize(chart.update);
          });
        }

        chart.lines.dispatch.on('elementClick', function(e) { if (zoom > 0) zoom--; time = e[0].point[0]; updateChart(); });
        $('#' + div + '-refresh-btn').click(function() { time = 0; updateChart(); });
        $('#' + div + '-zoomout-btn').click(function() { if (zoom < 4) zoom++; updateChart(); });

	return chart;
    });
  });
}

function drawPieChart(url, div, unit, counter, interval, items) {
  d3.json(url + '?counter=' + counter + '&interval=' + interval, function(data) {

    data.sort(function(a, b) { return (b.value - a.value); });
    data = data.slice(0, items);
    data = data.filter(function(n){ return n.value > 0; });

    nv.addGraph(function() {
        var chart = nv.models.pieChart()
                .x(function(d) { return d.label })
                .y(function(d) {
                        if (unit == 'bps') return d.value*8;
                        else return d.value; })
                .showLabels(true)
		.labelThreshold(.20)
                ;

        d3.select('#' + div + ' svg')
                .datum(data)
                .transition().duration(350)
                .call(chart);

        chart.pie.dispatch.on("elementClick", function(e) {
		location.href='?target=' + e.data.label;
        });

        nv.utils.windowResize(chart.update);

        function updateChart() {
          d3.json(url + '?counter=' + counter + '&interval=' + interval, function(data) {
        	data.sort(function(a, b) { return (b.value - a.value); });
        	data = data.slice(0, items);
        	d3.select('#' + div + ' svg')
        		.datum(data).transition().duration(500).call(chart);
        	nv.utils.windowResize(chart.update);
          });
        }

        $('#' + div + '-refresh-btn').click(function() { updateChart(); });

        return chart;
    });
  });
}

function newLineChart(container_div, div, title, desc, url, unit, initzoom, inittime) {
  createChartDiv(div, title, desc, container_div, 1);
  drawLineChart(url, div, unit, initzoom, inittime);
}

function newPieChart(container_div, div, title, desc, url, unit, counter, interval, items) {
  createChartDiv(div, title, desc, container_div, 0);
  drawPieChart(url, div, unit, counter, interval, items);
}

